## files.asp?artId=18659&file=0

=== CMakeLists.txt ===
# cmake <http://www.cmake.org> build file for Gammu
# Copyright (c) 2007 Michal Cihar
# vim: expandtab sw=4 ts=4 sts=4:

# I didn't check older versions
cmake_minimum_required (VERSION 2.4.2)

# Where to lookup modules
set (CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")

# Static library by default
set (ENABLE_SHARED FALSE CACHE BOOL "Build shared library")

set (BUILD_SHARED_LIBS ${ENABLE_SHARED} CACHE INTERNAL "Shared build")

# Support for cross compilation
if (UNIX)
    option (CROSS_MINGW "Cross compile using MinGW on linux" OFF)
else (UNIX)
    set (CROSS_MINGW OFF)
endif (UNIX)

if (CROSS_MINGW)
    message (STATUS "Cross compiling using MinGW")
    set (CMAKE_COMPILER_IS_GNUCC 1)
    set (CMAKE_COMPILER_IS_GNUCXX 1)

    find_program(MINGW_CXX_COMPILER
        NAMES i586-mingw32msvc-c++ i386-mingw32-c++ i686-pc-mingw32-c++
        PATHS
            /usr/local/bin/
            /usr/bin/
        DOC "MinGW C++ compiler binary")
    find_program(MINGW_C_COMPILER
        NAMES i586-mingw32msvc-gcc i386-mingw32-gcc i686-pc-mingw32-gcc
        PATHS
            /usr/local/bin/
            /usr/bin/
        DOC "MinGW C compiler binary")
    find_program(MINGW_AR
        NAMES i586-mingw32msvc-ar i386-mingw32-ar i686-pc-mingw32-ar
        PATHS
            /usr/local/bin/
            /usr/bin/
        DOC "MinGW ar binary")
    find_program(MINGW_RANLIB
        NAMES i586-mingw32msvc-ranlib i386-mingw32-ranlib i686-pc-mingw32-ranlib
        PATHS
            /usr/local/bin/
            /usr/bin/
        DOC "MinGW ranlib binary")
    set (CMAKE_CXX_COMPILER "${MINGW_CXX_COMPILER}")
    set (CMAKE_C_COMPILER "${MINGW_C_COMPILER}")
    set (CMAKE_AR "${MINGW_AR}")
    set (CMAKE_RANLIB "${MINGW_RANLIB}")
    set (WIN32 ON)
    set (MINGW ON)

    include (WindowsCross)

    # Detection not supported for cross compiling
    #    set (HAVE_ISWSPACE ON CACHE INTERNAL "")
    #    set (HAVE_TOWLOWER ON CACHE INTERNAL "")
    #    set (HAVE_WINT_T ON CACHE INTERNAL "")
    #    set (HAVE_WCHAR_T ON CACHE INTERNAL "")
    #    set (HAVE_WCTYPE_H ON CACHE INTERNAL "")
    #    set (HAVE_WCHAR_H ON CACHE INTERNAL "")

    # CPack configuration
    set (CPACK_GENERATOR "ZIP;NSIS")
    set (CPACK_SOURCE_GENERATOR "ZIP")
    set (CPACK_TOPLEVEL_TAG "Source")
    set (PACKAGE_NAME "Windows" CACHE STRING "Windows package name")
    set (CPACK_SYSTEM_NAME "${PACKAGE_NAME}")
endif (CROSS_MINGW)

# We've set up compiler, now we can use it
project (Gammu C)

if (CROSS_MINGW)
    include (WindowsCross)
endif (CROSS_MINGW)

# Set version
set (VERSION "1.20.0" CACHE INTERNAL "")
set (VERSION_WIN "1,20,0,0" CACHE INTERNAL "")
string (REGEX REPLACE "^([0-9]*)\\.([0-9]*)\\.([0-9]*)$" "\\1" "VERSION_MAJOR" "${VERSION}")
string (REGEX REPLACE "^([0-9]*)\\.([0-9]*)\\.([0-9]*)$" "\\2" "VERSION_MINOR" "${VERSION}")
string (REGEX REPLACE "^([0-9]*)\\.([0-9]*)\\.([0-9]*)$" "\\3" "VERSION_PATCH" "${VERSION}")
message (STATUS "Configuring ${CMAKE_PROJECT_NAME} ${VERSION}")

if ("${Gammu_BINARY_DIR}" STREQUAL "${Gammu_SOURCE_DIR}")
    message ("Warning: In tree build is not recommended way to build Gammu.")
endif ("${Gammu_BINARY_DIR}" STREQUAL "${Gammu_SOURCE_DIR}")

# For debugging
if (CMAKE_BUILD_TYPE STREQUAL "Debug")
#    set (CMAKE_VERBOSE_MAKEFILE ON)
    set (DEBUG 1)
else (CMAKE_BUILD_TYPE STREQUAL "Debug")
    set (DEBUG 0)
endif (CMAKE_BUILD_TYPE STREQUAL "Debug")

# Packaging support
set (CPACK_PACKAGE_NAME "Gammu")
set (CPACK_PACKAGE_VERSION "${VERSION}")
set (CPACK_PACKAGE_DESCRIPTION_SUMMARY "Gammu ${VERSION}")
set (CPACK_PACKAGE_VENDOR "Michal Čihař, Macin Wiacek and others")
set (CPACK_PACKAGE_DESCRIPTION_FILE "${CMAKE_CURRENT_SOURCE_DIR}/README")
set (CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/COPYING")
set (CPACK_PACKAGE_VERSION_MAJOR "${VERSION_MAJOR}")
set (CPACK_PACKAGE_VERSION_MINOR "${VERSION_MINOR}")
set (CPACK_PACKAGE_VERSION_PATCH "${VERSION_PATCH}")
if (WIN32)
  set (CPACK_PACKAGE_INSTALL_DIRECTORY "Gammu ${VERSION}")
  # There is a bug in NSI that does not handle full unix paths properly. Make
  # sure there is at least one set of four (4) backlasshes.
  #set (CPACK_PACKAGE_ICON "${CMake_SOURCE_DIR}/Utilities/Release\\\\InstallIcon.bmp")
  #set (CPACK_NSIS_INSTALLED_ICON_NAME "bin\\\\MyExecutable.exe")
  set (CPACK_NSIS_DISPLAY_NAME "${CPACK_PACKAGE_INSTALL_DIRECTORY}")
  set (CPACK_NSIS_HELP_LINK "http://www.gammu.org")
  set (CPACK_NSIS_URL_INFO_ABOUT "http://www.gammu.org")
  set (CPACK_NSIS_CONTACT "michal@cihar.com")
  set (CPACK_NSIS_MODIFY_PATH ON)
else (WIN32)
  set (CPACK_STRIP_FILES "gammu")
  set (CPACK_SOURCE_STRIP_FILES "")
endif (WIN32)
include (CPack)

# We want some tests. Even when cross compiling for Windows tests can be
# done in Wine. This is better than nothing, even though Wine is a bit
# more fault tolerant when linking DLLs.
include(CTest)

# Standard packages
include (CheckCSourceCompiles)
include (CheckCCompilerFlag)
include (CheckIncludeFile)
include (CheckFunctionExists)
include (CheckSymbolExists)
include (CheckTypeSize)

# Packages in our sources (mostly taken from KDE)
include (MacroOptionalFindPackage)
include (MacroGammuOption)
include (MacroTuneCompiler)

# WE use pkgconfig later
find_package (PkgConfig)

# Standard packages
macro_optional_find_package (Doxygen)

# Configuration checks
check_symbol_exists (strncasecmp "string.h" HAVE_STRNCASECMP)
check_symbol_exists (strcasecmp "string.h" HAVE_STRCASECMP)
check_function_exists (strcasestr HAVE_STRCASESTR)
check_function_exists (strchrnul HAVE_STRCHRNUL)
check_include_file (dirent.h HAVE_DIRENT_H)
check_include_file (sys/ioctl.h HAVE_SYS_IOCTL_H)
check_include_file (sys/utsname.h HAVE_SYS_UTSNAME_H)
check_include_file (wchar.h HAVE_WCHAR_H)
check_include_file (wctype.h HAVE_WCTYPE_H)
check_function_exists (scandir HAVE_SCANDIR)
check_function_exists (alphasort HAVE_ALPHASORT)
check_symbol_exists (iswspace "wctype.h" HAVE_ISWSPACE)
check_symbol_exists (towlower "wctype.h" HAVE_TOWLOWER)

# Check disabled for cross, but we have some libraries
if (CROSS_MINGW)

    set (MYSQL_CROSS_PATH "${Gammu_SOURCE_DIR}/../../win-cross/mysql" CACHE FILEPATH "Path to MySQL for cross compilation")
    find_library (MYSQL_LIBRARIES
        mysql "${MYSQL_CROSS_PATH}/lib/opt"
        NO_DEFAULT_PATH NO_CMAKE_PATH NO_CMAKE_ENVIRONMENT_PATH NO_SYSTEM_ENVIRONMENT_PATH NO_CMAKE_SYSTEM_PATH)
    if (MYSQL_LIBRARIES)
        set (MYSQL_FOUND ON)
        set (MYSQL_INCLUDE_DIR "${MYSQL_CROSS_PATH}/include")
        message (STATUS "Cross MySQL found, libs: ${MYSQL_LIBRARIES}, incs: ${MYSQL_INCLUDE_DIR}")
    else (MYSQL_LIBRARIES)
        message (STATUS "Cross MySQL not found")
    endif (MYSQL_LIBRARIES)

    set (POSTGRES_CROSS_PATH "${Gammu_SOURCE_DIR}/../../win-cross/pgsql" CACHE FILEPATH "Path to PostgreSQL for cross compilation")
    find_library (POSTGRES_LIBRARY
        pq "${POSTGRES_CROSS_PATH}/lib"
        NO_DEFAULT_PATH NO_CMAKE_PATH NO_CMAKE_ENVIRONMENT_PATH NO_SYSTEM_ENVIRONMENT_PATH NO_CMAKE_SYSTEM_PATH)
    if (POSTGRES_LIBRARY)
        set (POSTGRES_FOUND ON)
        set (POSTGRES_INCLUDE_DIR "${POSTGRES_CROSS_PATH}/include")
        message (STATUS "Cross PostgreSQL found, libs: ${POSTGRES_LIBRARY}, incs: ${POSTGRES_INCLUDE_DIR}")
    else (POSTGRES_LIBRARY)
        message (STATUS "Cross PostgreSQL not found")
    endif (POSTGRES_LIBRARY)

    set (GETTEXT_CROSS_PATH "${Gammu_SOURCE_DIR}/../../win-cross/gettext" CACHE FILEPATH "Path to Gettext for cross compilation")
    find_library (GETTEXT_LIBRARY
        intl "${GETTEXT_CROSS_PATH}/lib"
        NO_DEFAULT_PATH NO_CMAKE_PATH NO_CMAKE_ENVIRONMENT_PATH NO_SYSTEM_ENVIRONMENT_PATH NO_CMAKE_SYSTEM_PATH)
    if (GETTEXT_LIBRARY)
        set (GETTEXTLIBS_FOUND ON)
        set (GETTEXT_INCLUDE_DIR "${GETTEXT_CROSS_PATH}/include")
        message (STATUS "Cross Gettext found, libs: ${GETTEXT_LIBRARY}, incs: ${GETTEXT_INCLUDE_DIR}")
    else (GETTEXT_LIBRARY)
        message (STATUS "Cross Gettext not found")
    endif (GETTEXT_LIBRARY)

    set (HAVE_WINT_T 4 CACHE INTERNAL "")
    set (HAVE_WCHAR_T 4 CACHE INTERNAL "")
else (CROSS_MINGW)
    # Standard packages
    macro_optional_find_package (Threads)

    # Packages in sources
    macro_optional_find_package (MySQL)
    macro_optional_find_package (Postgres)
    macro_optional_find_package (GettextLibs)
    macro_optional_find_package (Iconv)

    # Search for needed includes and functions
    if (HAVE_WCHAR_H)
        set (CMAKE_EXTRA_INCLUDE_FILES wchar.h)
        check_type_size (wchar_t HAVE_WCHAR_T)
    endif (HAVE_WCHAR_H)
    if (HAVE_WCTYPE_H)
        set (CMAKE_EXTRA_INCLUDE_FILES wctype.h)
        check_type_size (wint_t  HAVE_WINT_T)
    endif (HAVE_WCTYPE_H)
    set (CMAKE_EXTRA_INCLUDE_FILES)
endif (CROSS_MINGW)

OPTION(WITH_BLUETOOTH "Bluetooth support" ON)
if (WITH_BLUETOOTH)
    if (WIN32)
        # FIXME: This is currently hardcoded here, maybe there is test?
        set(BLUETOOTH_FOUND ON)
        set(BLUETOOTH_INCLUDE_DIR)
        set(BLUETOOTH_INCLUDES)
        set(BLUETOOTH_LIBRARY)
        set(BLUETOOTH_LIBRARIES)
        set(BLUETOOTH_SEARCH TRUE)
    else (WIN32)
        find_package (Bluez)
        if (BLUEZ_FOUND)
            set(BLUETOOTH_FOUND ON)
            set (GSM_ENABLE_BLUEZ TRUE)
            set(BLUETOOTH_SEARCH TRUE)
        endif (BLUEZ_FOUND)
        find_package (FBSDBluetooth)
        if (FBSD_BLUE_FOUND)
            set(BLUETOOTH_FOUND ON)
            set (GSM_ENABLE_FBSD_BLUE TRUE)
            set(BLUETOOTH_SEARCH FALSE)
        endif (FBSD_BLUE_FOUND)
    endif (WIN32)
else (WITH_BLUETOOTH)
    set(BLUETOOTH_FOUND)
    set(BLUETOOTH_INCLUDE_DIR)
    set(BLUETOOTH_INCLUDES)
    set(BLUETOOTH_LIBRARY)
    set(BLUETOOTH_LIBRARIES)
endif (WITH_BLUETOOTH)

if (BLUETOOTH_FOUND)
    message(STATUS "Bluetooth support enabled")
endif (BLUETOOTH_FOUND)

macro_gammu_option (BLUETOOTH_RF_SEARCHING "Searching for RF channels with Bluetooth stack" ON BLUETOOTH_FOUND BLUETOOTH_SEARCH)
if (WITH_BLUETOOTH_RF_SEARCHING)
    set (BLUETOOTH_RF_SEARCHING ON)
endif (WITH_BLUETOOTH_RF_SEARCHING)

OPTION(WITH_IRDA "IrDA support" ON)
if (WITH_IRDA)
    if (WIN32)
        # FIXME: This is currently hardcoded here, maybe there is test?
        set (IRDA_FOUND YES)
    else (WIN32)
        check_c_source_compiles (
            "
#include <sys/socket.h>
#include <linux/types.h>
#include <sys/ioctl.h>
#include <linux/irda.h>
    int main(int argc, char **argv) {
        return 0;
    }
            "
            IRDA_FOUND
            )
    endif (WIN32)
else (WITH_IRDA)
    set (IRDA_FOUND)
endif (WITH_IRDA)

if (IRDA_FOUND)
    message(STATUS "IrDA support enabled")
endif (IRDA_FOUND)

if (MYSQL_FOUND)
    set (HAVE_MYSQL_MYSQL_H TRUE)
endif (MYSQL_FOUND)

if (POSTGRES_FOUND)
    set (HAVE_POSTGRESQL_LIBPQ_FE_H TRUE)
endif (POSTGRES_FOUND)

set (GAMMU_LIBS "")

if (BLUEZ_FOUND)
    if (NOT "${BLUEZ_LIBRARIES}" STREQUAL "")
        set (GAMMU_LIBS "${GAMMU_LIBS} -l${BLUEZ_LIBRARIES}")
    endif (NOT "${BLUEZ_LIBRARIES}" STREQUAL "")
endif (BLUEZ_FOUND)

if (FBSD_BLUE_FOUND)
    if (NOT "${FBSD_BLUE_LIBRARIES}" STREQUAL "")
        set (GAMMU_LIBS "${GAMMU_LIBS} -l${FBSD_BLUE_LIBRARIES}")
    endif (NOT "${FBSD_BLUE_LIBRARIES}" STREQUAL "")
endif (FBSD_BLUE_FOUND)

if (ICONV_FOUND)
    if (NOT "${ICONV_LIBRARIES}" STREQUAL "")
        set (GAMMU_LIBS "${GAMMU_LIBS} -l${ICONV_LIBRARIES}")
    endif (NOT "${ICONV_LIBRARIES}" STREQUAL "")
endif (ICONV_FOUND)

if (GETTEXTLIBS_FOUND)
    if (NOT "${GETTEXT_LIBRARIES}" STREQUAL "" AND NOT "${GETTEXT_LIBRARIES}" STREQUAL "/usr/lib/libc.so")
        set (GAMMU_LIBS "${GAMMU_LIBS} -l${GETTEXT_LIBRARIES}")
    endif (NOT "${GETTEXT_LIBRARIES}" STREQUAL "" AND NOT "${GETTEXT_LIBRARIES}" STREQUAL "/usr/lib/libc.so")
endif (GETTEXTLIBS_FOUND)

# Tweak compiler flags
if(MSVC)
    # MSVC needs different flags at all
    check_c_compiler_flag("/W3" HAVE_W3)
    if (HAVE_W3)
        set (CMAKE_C_FLAGS     "${CMAKE_C_FLAGS} /W3")

=== common/CMakeLists.txt ===
# cmake <http://www.cmake.org> build file for Gammu
# Copyright (c) 2007 Michal Cihar
# vim: expandtab sw=4 ts=4 sts=4:

project (libGammu C)

set (LIBRARY_SRC
    gsmcomon.c
    gsmphones.c
    gsmstate.c
    api.c
    misc/misc.c
    misc/cfg.c
    misc/coding/coding.c
    misc/coding/md5.c
    service/sms/gsmsms.c
    service/sms/gsmems.c
    service/sms/gsmmulti.c
    service/gsmcal.c
    service/gsmdata.c
    service/gsmpbk.c
    service/gsmring.c
    service/gsmlogo.c
    service/gsmmisc.c
    service/gsmnet.c
    service/backup/gsmback.c
    service/backup/backldif.c
    service/backup/backlmb.c
    service/backup/backtext.c
    service/backup/backvcs.c
    service/backup/backvcf.c
    service/backup/backics.c
    device/bluetoth/bluez.c
    device/bluetoth/blue_fbsd.c
    device/bluetoth/blue_w32.c
    device/bluetoth/bluetoth.c
    device/serial/ser_unx.c
    device/serial/ser_djg.c
    device/serial/ser_w32.c
    device/irda/irda.c
    device/devfunc.c
    protocol/at/at.c
    protocol/alcatel/alcabus.c
    protocol/nokia/mbus2.c
    protocol/nokia/fbus2.c
    protocol/nokia/phonet.c
    protocol/obex/obex.c
    protocol/symbian/gnapbus.c
    phone/pfunc.c
    phone/at/atgen.c
    phone/at/siemens.c
    phone/at/samsung.c
    phone/at/motorola.c
    phone/alcatel/alcatel.c
    phone/atobex/atobex.c
    phone/nokia/dct3/n0650.c
    phone/nokia/dct3/n6110.c
    phone/nokia/dct3/n7110.c
    phone/nokia/dct3/n9210.c
    phone/nokia/dct3/dct3func.c
    phone/nokia/dct4s40/n3320.c
    phone/nokia/dct4s40/dct4func.c
    phone/nokia/dct4s40/6510/n6510.c
    phone/nokia/dct4s40/6510/6510cal.c
    phone/nokia/dct4s40/6510/6510file.c
    phone/nokia/wd2/n3650.c
    phone/nokia/nauto.c
    phone/nokia/nfunc.c
    phone/nokia/nfuncold.c
    phone/obex/obexgen.c
    phone/symbian/gnapgen.c)

# Library
add_library (libGammu ${LIBRARY_SRC})
if (CROSS_MINGW)
    if (ENABLE_SHARED)
        set_target_properties (libGammu PROPERTIES
            PREFIX ""
            SUFFIX ".dll"
            IMPORT_PREFIX ""
            IMPORT_SUFFIX ".lib"
            )
    else (ENABLE_SHARED)
        set_target_properties (libGammu PROPERTIES PREFIX "" SUFFIX ".lib")
    endif (ENABLE_SHARED)
else (CROSS_MINGW)
    # -fPIC on Linux
    if (CMAKE_SYSTEM_NAME MATCHES "Linux")
        set_target_properties (libGammu PROPERTIES COMPILE_FLAGS "-fPIC")
    endif (CMAKE_SYSTEM_NAME MATCHES "Linux")

endif (CROSS_MINGW)

if (NOT CROSS_MINGW)
    set_target_properties (libGammu PROPERTIES VERSION 3.${VERSION} SOVERSION 3)
endif (NOT CROSS_MINGW)
set_target_properties(libGammu PROPERTIES OUTPUT_NAME Gammu)

if (BLUEZ_FOUND)
    target_link_libraries (libGammu ${BLUEZ_LIBRARIES})
    include_directories (${BLUEZ_INCLUDE_DIR})
endif (BLUEZ_FOUND)

if (FBSD_BLUE_FOUND)
    target_link_libraries (libGammu ${FBSD_BLUE_LIBRARIES})
    include_directories (${FBSD_BLUE_INCLUDE_DIR})
endif (FBSD_BLUE_FOUND)

if (ICONV_FOUND)
    target_link_libraries (libGammu ${ICONV_LIBRARIES})
    include_directories (${ICONV_INCLUDE_DIR})
endif (ICONV_FOUND)

if (UNIX)
    target_link_libraries (libGammu m)
endif (UNIX)

# Include search path
include_directories ("${Gammu_BINARY_DIR}/include")
include_directories ("${Gammu_SOURCE_DIR}/common")

# Add libraries needed for windows build
if (WIN32)
    # Magic needed for SHGetFolderPathA
    target_link_libraries (libGammu shfolder shell32)
    # Win sock
    target_link_libraries (libGammu ws2_32)
    # These libraries are needed for serial driver
    target_link_libraries (libGammu setupapi advapi32)
endif (WIN32)

if (GETTEXTLIBS_FOUND)
    target_link_libraries (libGammu ${GETTEXT_LIBRARY})
    include_directories (${GETTEXT_INCLUDE_DIR})
endif (GETTEXTLIBS_FOUND)

# Install instructions
install (TARGETS libGammu
        RUNTIME DESTINATION "${INSTALL_BIN_DIR}"
        LIBRARY DESTINATION "${INSTALL_LIB_DIR}"
        ARCHIVE DESTINATION "${INSTALL_LIB_DIR}"
        )

=== gammu/CMakeLists.txt ===
# cmake <http://www.cmake.org> build file for Gammu
# Copyright (c) 2007 Michal Cihar
# vim: expandtab sw=4 ts=4 sts=4:

project (gammu-binary C)

if (HAVE_WNOUNUSEDPARAMETER)
    set (CMAKE_C_FLAGS     "${CMAKE_C_FLAGS} -Wno-unused-parameter")
endif (HAVE_WNOUNUSEDPARAMETER)

set (BINARY_SRC
    depend/nokia/dct3.c
    depend/nokia/dct3trac/wmx.c
    depend/nokia/dct3trac/wmx-gsm.c
    depend/nokia/dct3trac/wmx-list.c
    depend/nokia/dct3trac/wmx-sim.c
    depend/nokia/dct3trac/wmx-util.c
    depend/nokia/dct4.c
    depend/siemens/dsiemens.c
    depend/siemens/chiffre.c
    smsd/smsdcore.c
    smsd/s_files.c
    smsd/s_mysql.c
    smsd/s_pgsql.c
    sniff.c
    common.c
    memory.c
    message.c
    search.c
    nokia.c
    backup.c
    files.c
    calendar.c
    misc.c
    gammu.c)


# Hides default case in switch, to allow checking whether all cases are handled.
if(DEBUG)
    add_definitions(-DCHECK_CASES)
endif(DEBUG)

# Gammu program
add_executable (gammu ${BINARY_SRC})
if (CROSS_MINGW)
    set_target_properties (gammu PROPERTIES PREFIX "" SUFFIX ".exe")
endif (CROSS_MINGW)

target_link_libraries (gammu libGammu)
target_link_libraries (gammu ${CMAKE_THREAD_LIBS_INIT})

include_directories (
    "${Gammu_BINARY_DIR}/include"
    )
# Tune options for found libraries
if (MYSQL_FOUND)
    target_link_libraries (gammu ${MYSQL_LIBRARIES})
    include_directories (${MYSQL_INCLUDE_DIR})
endif (MYSQL_FOUND)

if (POSTGRES_FOUND)
    target_link_libraries (gammu ${POSTGRES_LIBRARY})
    include_directories (${POSTGRES_INCLUDE_DIR})
endif (POSTGRES_FOUND)

if (GETTEXTLIBS_FOUND)
    target_link_libraries (gammu ${GETTEXT_LIBRARY})
    include_directories (${GETTEXT_INCLUDE_DIR})
endif (GETTEXTLIBS_FOUND)

# Add libraries needed for windows build
if (WIN32)
    # Magic needed for SHGetFolderPathA
    target_link_libraries (gammu shfolder shell32)
    # Win sock
    target_link_libraries (gammu ws2_32)
    # These libraries are needed for serial driver
    target_link_libraries (gammu setupapi advapi32)
endif (WIN32)

install (TARGETS gammu
        RUNTIME DESTINATION "${INSTALL_BIN_DIR}"
        LIBRARY DESTINATION "${INSTALL_LIB_DIR}"
        ARCHIVE DESTINATION "${INSTALL_LIB_DIR}"
        )

=== tests/CMakeLists.txt ===
# cmake <http://www.cmake.org> build file for Gammu
# Copyright (c) 2007 Michal Cihar
# vim: expandtab sw=4 ts=4 sts=4:

project (gammu-tests C)

# Define path for cmake tests
if (EXECUTABLE_OUTPUT_PATH)
    set (GAMMU_TEST_PATH "${EXECUTABLE_OUTPUT_PATH}/")
else (EXECUTABLE_OUTPUT_PATH)
    set (GAMMU_TEST_PATH "${CMAKE_CURRENT_BINARY_DIR}/")
endif (EXECUTABLE_OUTPUT_PATH)
if (CROSS_MINGW)
    set (GAMMU_TEST_SUFFIX ".exe")
else (CROSS_MINGW)
    set (GAMMU_TEST_SUFFIX "")
endif (CROSS_MINGW)

# We use Gammu
include_directories("${Gammu_BINARY_DIR}/include")

# Basic check for statemachine allocation
add_executable(statemachine-alloc statemachine-alloc.c)
if (CROSS_MINGW)
    set_target_properties (statemachine-alloc PROPERTIES PREFIX "" SUFFIX ".exe")
endif (CROSS_MINGW)

target_link_libraries(statemachine-alloc libGammu)
add_test(statemachine-alloc "${GAMMU_TEST_PATH}/statemachine-alloc${GAMMU_TEST_SUFFIX}")

# Check error code  descriptions
add_executable(dump-error-codes dump-error-codes.c)
if (CROSS_MINGW)
    set_target_properties (dump-error-codes PROPERTIES PREFIX "" SUFFIX ".exe")
endif (CROSS_MINGW)

target_link_libraries(dump-error-codes libGammu)
add_test(dump-error-codes "${GAMMU_TEST_PATH}/dump-error-codes${GAMMU_TEST_SUFFIX}" "-n")

# Check feature code names
add_executable(dump-features dump-features.c)
if (CROSS_MINGW)
    set_target_properties (dump-features PROPERTIES PREFIX "" SUFFIX ".exe")
endif (CROSS_MINGW)

target_link_libraries(dump-features libGammu)
add_test(dump-features "${GAMMU_TEST_PATH}/dump-features${GAMMU_TEST_SUFFIX}" "-n")

# Check feature parsing
add_executable(features-parsing features-parsing.c)
if (CROSS_MINGW)
    set_target_properties (features-parsing PROPERTIES PREFIX "" SUFFIX ".exe")
endif (CROSS_MINGW)

target_link_libraries(features-parsing libGammu)
add_test(features-parsing "${GAMMU_TEST_PATH}/features-parsing${GAMMU_TEST_SUFFIX}" "-n")

# Check network codes decoding
add_executable(network-codes network-codes.c)
if (CROSS_MINGW)
    set_target_properties (network-codes PROPERTIES PREFIX "" SUFFIX ".exe")
endif (CROSS_MINGW)

target_link_libraries(network-codes libGammu)
add_test(network-codes "${GAMMU_TEST_PATH}/network-codes${GAMMU_TEST_SUFFIX}" "-n")

# vCard parsing
add_executable(vcard-read vcard-read.c)
if (CROSS_MINGW)
    set_target_properties (vcard-read PROPERTIES PREFIX "" SUFFIX ".exe")
endif (CROSS_MINGW)
target_link_libraries(vcard-read libGammu)

# List test cases
file(GLOB VCARDS
    RELATIVE "${Gammu_SOURCE_DIR}/tests/vcards"
    "${Gammu_SOURCE_DIR}/tests/vcards/*.vcf")
list(SORT VCARDS)

foreach(TESTVCARD ${VCARDS})
    string(REPLACE vcf backup TESTBACKUP ${TESTVCARD})
    string(REPLACE .vcf "" TESTNAME ${TESTVCARD})
    add_test("vcard-read-${TESTNAME}"
        "${GAMMU_TEST_PATH}/vcard-read${GAMMU_TEST_SUFFIX}"
        "${Gammu_SOURCE_DIR}/tests/vcards/${TESTVCARD}"
        "${Gammu_SOURCE_DIR}/tests/vcards/${TESTBACKUP}")
endforeach(TESTVCARD $VCARDS)

# [iv]Calendar parsing
add_executable(cal-read cal-read.c)
if (CROSS_MINGW)
    set_target_properties (cal-read PROPERTIES PREFIX "" SUFFIX ".exe")
endif (CROSS_MINGW)
target_link_libraries(cal-read libGammu)

# List test cases
file(GLOB VCALS
    RELATIVE "${Gammu_SOURCE_DIR}/tests/vcal"
    "${Gammu_SOURCE_DIR}/tests/vcal/*.vcs")
list(SORT VCALS)

foreach(TESTVCAL ${VCALS})
    string(REPLACE vcs backup TESTBACKUP ${TESTVCAL})
    string(REPLACE .vcs "" TESTNAME ${TESTVCAL})
    add_test("cal-read-${TESTNAME}"
        "${GAMMU_TEST_PATH}/cal-read${GAMMU_TEST_SUFFIX}"
        "${Gammu_SOURCE_DIR}/tests/vcal/${TESTVCAL}"
        "${Gammu_SOURCE_DIR}/tests/vcal/${TESTBACKUP}")
endforeach(TESTVCAL $VCALS)

# List test cases
file(GLOB VCALS
    RELATIVE "${Gammu_SOURCE_DIR}/tests/vcal"
    "${Gammu_SOURCE_DIR}/tests/vcal/*.ics")
list(SORT VCALS)

foreach(TESTVCAL ${VCALS})
    string(REPLACE ics backup TESTBACKUP ${TESTVCAL})
    string(REPLACE .ics "" TESTNAME ${TESTVCAL})
    add_test("cal-read-${TESTNAME}"
        "${GAMMU_TEST_PATH}/cal-read${GAMMU_TEST_SUFFIX}"
        "${Gammu_SOURCE_DIR}/tests/vcal/${TESTVCAL}"
        "${Gammu_SOURCE_DIR}/tests/vcal/${TESTBACKUP}")
endforeach(TESTVCAL $VCALS)

# SMS parsing
add_executable(sms-nokia-01 sms-nokia-01.c sms-printing.c)
if (CROSS_MINGW)
    set_target_properties (sms-nokia-01 PROPERTIES PREFIX "" SUFFIX ".exe")
endif (CROSS_MINGW)
target_link_libraries(sms-nokia-01 libGammu)
add_test(sms-nokia-01 "${GAMMU_TEST_PATH}/sms-nokia-01${GAMMU_TEST_SUFFIX}")
add_executable(sms-nokia-02 sms-nokia-02.c sms-printing.c)
if (CROSS_MINGW)
    set_target_properties (sms-nokia-02 PROPERTIES PREFIX "" SUFFIX ".exe")
endif (CROSS_MINGW)
target_link_libraries(sms-nokia-02 libGammu)
add_test(sms-nokia-02 "${GAMMU_TEST_PATH}/sms-nokia-02${GAMMU_TEST_SUFFIX}")
add_executable(sms-nokia-03 sms-nokia-03.c sms-printing.c)
if (CROSS_MINGW)
    set_target_properties (sms-nokia-03 PROPERTIES PREFIX "" SUFFIX ".exe")
endif (CROSS_MINGW)
target_link_libraries(sms-nokia-03 libGammu)
add_test(sms-nokia-03 "${GAMMU_TEST_PATH}/sms-nokia-03${GAMMU_TEST_SUFFIX}")
add_executable(sms-nokia-04 sms-nokia-04.c sms-printing.c)
if (CROSS_MINGW)
    set_target_properties (sms-nokia-04 PROPERTIES PREFIX "" SUFFIX ".exe")
endif (CROSS_MINGW)
target_link_libraries(sms-nokia-04 libGammu)
add_test(sms-nokia-04 "${GAMMU_TEST_PATH}/sms-nokia-04${GAMMU_TEST_SUFFIX}")

# AT SMS parsing
add_executable(sms-at-parse sms-at-parse.c sms-printing.c)
if (CROSS_MINGW)
    set_target_properties (sms-at-parse PROPERTIES PREFIX "" SUFFIX ".exe")
endif (CROSS_MINGW)
target_link_libraries(sms-at-parse libGammu)

# AT SMS parsing - simple PDU decoder
add_executable(pdu-decode pdu-decode.c)
if (CROSS_MINGW)
    set_target_properties (pdu-decode PROPERTIES PREFIX "" SUFFIX ".exe")
endif (CROSS_MINGW)

# List test cases for success
file(GLOB MESSAGES
    RELATIVE "${Gammu_SOURCE_DIR}/tests/at-sms"
    "${Gammu_SOURCE_DIR}/tests/at-sms/*.dump")
list(SORT MESSAGES)

foreach(TESTMESSAGE ${MESSAGES})
    string(REPLACE .dump "" TESTNAME ${TESTMESSAGE})
    add_test("sms-at-parse-${TESTNAME}"
        "${GAMMU_TEST_PATH}/sms-at-parse${GAMMU_TEST_SUFFIX}"
        "${Gammu_SOURCE_DIR}/tests/at-sms/${TESTMESSAGE}")
    add_test("pdu-decode-${TESTNAME}"
        "${GAMMU_TEST_PATH}/pdu-decode${GAMMU_TEST_SUFFIX}"
        "${Gammu_SOURCE_DIR}/tests/at-sms/${TESTMESSAGE}")
endforeach(TESTMESSAGE $MESSAGES)

# List test cases for failure
file(GLOB MESSAGES
    RELATIVE "${Gammu_SOURCE_DIR}/tests/at-sms-failing"
    "${Gammu_SOURCE_DIR}/tests/at-sms-failing/*.dump")
list(SORT MESSAGES)

foreach(TESTMESSAGE ${MESSAGES})
    string(REPLACE .dump "" TESTNAME ${TESTMESSAGE})
    add_test("sms-at-parse-fail-${TESTNAME}"
        "${GAMMU_TEST_PATH}/sms-at-parse${GAMMU_TEST_SUFFIX}"
        "${Gammu_SOURCE_DIR}/tests/at-sms-failing/${TESTMESSAGE}")
    add_test("pdu-decode-fail-${TESTNAME}"
        "${GAMMU_TEST_PATH}/pdu-decode${GAMMU_TEST_SUFFIX}"
        "${Gammu_SOURCE_DIR}/tests/at-sms-failing/${TESTMESSAGE}")
    set_tests_properties(
        "pdu-decode-fail-${TESTNAME}"
        "sms-at-parse-fail-${TESTNAME}"
        PROPERTIES WILL_FAIL TRUE)
endforeach(TESTMESSAGE $MESSAGES)

# List test cases
file(GLOB MESSAGES
    RELATIVE "${Gammu_SOURCE_DIR}/tests/at-sms"
    "${Gammu_SOURCE_DIR}/tests/at-sms/*.dump")
list(SORT MESSAGES)

foreach(TESTMESSAGE ${MESSAGES})
    string(REPLACE .dump "" TESTNAME ${TESTMESSAGE})
endforeach(TESTMESSAGE $MESSAGES)

# AT model parsing
add_executable(get-model-at get-model-at.c)
if (CROSS_MINGW)
    set_target_properties (get-model-at PROPERTIES PREFIX "" SUFFIX ".exe")
endif (CROSS_MINGW)
target_link_libraries(get-model-at libGammu)

# List test cases
file(GLOB MESSAGES
    RELATIVE "${Gammu_SOURCE_DIR}/tests/at-model"
    "${Gammu_SOURCE_DIR}/tests/at-model/*.dump")
list(SORT MESSAGES)

foreach(TESTMESSAGE ${MESSAGES})
    string(REPLACE .dump "" TESTNAME ${TESTMESSAGE})
    add_test("get-model-at-${TESTNAME}"
        "${GAMMU_TEST_PATH}/get-model-at${GAMMU_TEST_SUFFIX}"
        "${Gammu_SOURCE_DIR}/tests/at-model/${TESTMESSAGE}")
endforeach(TESTMESSAGE $MESSAGES)

# AT SMSC parsing
add_executable(get-smsc-at get-smsc-at.c)
if (CROSS_MINGW)
    set_target_properties (get-smsc-at PROPERTIES PREFIX "" SUFFIX ".exe")
endif (CROSS_MINGW)
target_link_libraries(get-smsc-at libGammu)

# List test cases
file(GLOB MESSAGES
    RELATIVE "${Gammu_SOURCE_DIR}/tests/at-smsc"
    "${Gammu_SOURCE_DIR}/tests/at-smsc/*.dump")
list(SORT MESSAGES)

foreach(TESTMESSAGE ${MESSAGES})
    string(REPLACE .dump "" TESTNAME ${TESTMESSAGE})
    add_test("get-smsc-at-${TESTNAME}"
        "${GAMMU_TEST_PATH}/get-smsc-at${GAMMU_TEST_SUFFIX}"
        "${Gammu_SOURCE_DIR}/tests/at-smsc/${TESTMESSAGE}")
endforeach(TESTMESSAGE $MESSAGES)

# AT SMS encoding
add_executable(sms-at-encode sms-at-encode.c sms-printing.c)
if (CROSS_MINGW)
    set_target_properties (sms-at-encode PROPERTIES PREFIX "" SUFFIX ".exe")
endif (CROSS_MINGW)
target_link_libraries(sms-at-encode libGammu)

# List test cases
file(GLOB MESSAGES
    RELATIVE "${Gammu_SOURCE_DIR}/tests/at-sms-encode"
    "${Gammu_SOURCE_DIR}/tests/at-sms-encode/*.backup")
list(SORT MESSAGES)

foreach(TESTMESSAGE ${MESSAGES})
    string(REPLACE .backup "" TESTNAME ${TESTMESSAGE})
    string(REPLACE backup dump TESTDUMP ${TESTMESSAGE})
    add_test("sms-at-encode-${TESTNAME}"
        "${GAMMU_TEST_PATH}/sms-at-encode${GAMMU_TEST_SUFFIX}"
        "${Gammu_SOURCE_DIR}/tests/at-sms-encode/${TESTMESSAGE}"
        "${Gammu_SOURCE_DIR}/tests/at-sms-encode/${TESTDUMP}")
endforeach(TESTMESSAGE $MESSAGES)

# SMS encoding
add_executable(sms-encode-decode sms-encode-decode.c sms-printing.c)
if (CROSS_MINGW)
    set_target_properties (sms-encode-decode PROPERTIES PREFIX "" SUFFIX ".exe")
endif (CROSS_MINGW)
target_link_libraries(sms-encode-decode libGammu)
add_test(sms-encode-decode "${GAMMU_TEST_PATH}/sms-encode-decode${GAMMU_TEST_SUFFIX}")

# AT parser tests
add_executable(at-parser at-parser.c)
if (CROSS_MINGW)
    set_target_properties (at-parser PROPERTIES PREFIX "" SUFFIX ".exe")
endif (CROSS_MINGW)
target_link_libraries(at-parser libGammu)
add_test(at-parser "${GAMMU_TEST_PATH}/at-parser${GAMMU_TEST_SUFFIX}")

# Line parser tests
add_executable(line-splitting line-splitting.c)
if (CROSS_MINGW)
    set_target_properties (line-splitting PROPERTIES PREFIX "" SUFFIX ".exe")
endif (CROSS_MINGW)
target_link_libraries(line-splitting libGammu)
add_test(line-splitting "${GAMMU_TEST_PATH}/line-splitting${GAMMU_TEST_SUFFIX}")

# Just try to compile example whether it is still correct
add_executable(phone-info "${Gammu_SOURCE_DIR}/docs/develop/examples/phone-info.c")
if (CROSS_MINGW)
    set_target_properties (phone-info PROPERTIES PREFIX "" SUFFIX ".exe")
endif (CROSS_MINGW)
target_link_libraries(phone-info libGammu)
add_executable(sms-send "${Gammu_SOURCE_DIR}/docs/develop/examples/sms-send.c")
if (CROSS_MINGW)
    set_target_properties (sms-send PROPERTIES PREFIX "" SUFFIX ".exe")
endif (CROSS_MINGW)
target_link_libraries(sms-send libGammu)


# Auto generated include tests begin
# Do not modify this section, change gen-include-test.sh instead

# Test for header gammu-backup.h
add_executable(include-backup include-backup.c)
if (CROSS_MINGW)
    set_target_properties (include-backup PROPERTIES PREFIX "" SUFFIX ".exe")
endif (CROSS_MINGW)
target_link_libraries(include-backup libGammu)
add_test(include-backup "${GAMMU_TEST_PATH}/include-backup${GAMMU_TEST_SUFFIX}")

# Test for header gammu-bitmap.h
add_executable(include-bitmap include-bitmap.c)
if (CROSS_MINGW)
    set_target_properties (include-bitmap PROPERTIES PREFIX "" SUFFIX ".exe")
endif (CROSS_MINGW)
target_link_libraries(include-bitmap libGammu)
add_test(include-bitmap "${GAMMU_TEST_PATH}/include-bitmap${GAMMU_TEST_SUFFIX}")

# Test for header gammu-calendar.h
add_executable(include-calendar include-calendar.c)
if (CROSS_MINGW)

=== packaging/debian/control ===
Source: gammu
Section: comm
Priority: optional
Maintainer: Michal Cihar <michal@cihar.com>
Build-Depends: debhelper (>= 4.0.0), libc6-dev, libbluetooth1, libbluetooth1-dev, autoconf
Standards-Version: 3.6.0

Package: gammu
Architecture: any
Depends: ${shlibs:Depends}
Suggests: wammu
Description: Mobile phone management utility
 Gammu (Gammu All Mobile Management Utility) is program to manage mobile phone.
 .
 Gammu can do such things with cellular phones as making data calls,
 updating the address book, changing calendar and ToDo entries, sending and
 receiving SMS messages, loading and getting ring tones and pictures (different
 types of logos), synchronizing time, enabling NetMonitor, managing WAP
 settings and bookmarks and much more. Functions depend on the phone model.
 .
 Currently supported phones are:
 .
  * Many Nokia phones.
  * Alcatel BE5 (501/701), BF5 (715), BH4 (535/735).
  * Any AT capable phone (Siemens, Nokia, Alcatel, IPAQ).
 .
 This package contains gammu binary.

Package: libgammu1-dev
Replaces: libgammu-dev
Conflicts: libgammu-dev, libgammu
Section: libdevel
Architecture: any
Depends: libgammu1 (= ${Source-Version})
Description: Header files for Gammu
 Gammu (Gammu All Mobile Management Utility) is program to manage mobile phone.
 .
 Gammu can do such things with cellular phones as making data calls,
 updating the address book, changing calendar and ToDo entries, sending and
 receiving SMS messages, loading and getting ring tones and pictures (different
 types of logos), synchronizing time, enabling NetMonitor, managing WAP
 settings and bookmarks and much more. Functions depend on the phone model.
 .
 Currently supported phones are:
 .
  * Many Nokia phones.
  * Alcatel BE5 (501/701), BF5 (715), BH4 (535/735).
  * Any AT capable phone (Siemens, Nokia, Alcatel, IPAQ).
 .
 This package contains header files needed for compiling programs with Gammu.

Package: libgammu1
Replaces: libgammu
Conflicts: libgammu
Suggests: gammu
Section: libs
Architecture: any
Depends: ${shlibs:Depends}
Description:  Mobile phone management library
 Gammu (Gammu All Mobile Management Utility) is program to manage mobile phone.
 .
 Gammu can do such things with cellular phones as making data calls,
 updating the address book, changing calendar and ToDo entries, sending and
 receiving SMS messages, loading and getting ring tones and pictures (different
 types of logos), synchronizing time, enabling NetMonitor, managing WAP
 settings and bookmarks and much more. Functions depend on the phone model.
 .
 Currently supported phones are:
 .
  * Many Nokia phones.
  * Alcatel BE5 (501/701), BF5 (715), BH4 (535/735).
  * Any AT capable phone (Siemens, Nokia, Alcatel, IPAQ).
 .
 This package contains Gammu library.
